package netscape.debug;

import java.lang.reflect.Method;

public class ThreadHook extends Hook {
   private Thread thread;
   int observations;
   public static final int THR_OBSERVE_INTERRUPTS = 1;
   public static final int THR_OBSERVE_SYNCHRONIZATION = 2;
   public static final int THR_OBSERVE_EXCEPTIONS = 4;
   public static final int THR_OBSERVE_STEPS = 8;
   public static final int THR_OBSERVE_BRANCHES = 16;
   public static final int THR_OBSERVE_CALLS = 32;

   public ThreadHook(Thread var1) {
      this.thread = var1;
      this.observations = 7;
   }

   public boolean isObserving(int var1) {
      return (this.observations & var1) != 0;
   }

   public boolean setObserving(int var1, boolean var2) {
      boolean var3 = (this.observations & var1) != 0;
      if (var2) {
         this.observations |= var1;
      } else {
         this.observations &= ~var1;
      }

      return var3;
   }

   public Thread getThread() {
      return this.thread;
   }

   void justInterrupted(ThreadState var1) {
   }

   void justThrew(ThreadState var1, Throwable var2) {
   }

   void justCaught(ThreadState var1, Throwable var2) {
   }

   void aboutToExecute(ThreadState var1) {
   }

   void justBranched(ThreadState var1) {
   }

   void justEntered(ThreadState var1, Method var2) {
   }

   void aboutToExit(ThreadState var1, Method var2) {
   }

   void justLocked(ThreadState var1, Object var2) {
   }

   void aboutToUnlock(ThreadState var1, Object var2) {
   }

   void aboutToWait(ThreadState var1, Object var2) {
   }

   void justReentered(ThreadState var1, Object var2) {
   }
}
